;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; SMW Big Boo (sprite 28), by imamelia
;;
;; This is a disassembly of sprite 28 in SMW, the Big Boo.
;;
;; Uses first extra bit: YES
;;
;; If the first extra bit is set, the Big Boo will keep following you even when you look away.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; defines and tables
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SpeedMax:
db $08,$F8

IncTable:
db $01,$FF

Frame:
db $01,$02,$02,$01

XDisp:
db $08,$08,$20,$00,$00,$00,$00,$10
db $10,$10,$10,$20,$20,$20,$20,$30
db $30,$30,$30,$FD,$0C,$0C,$27,$00
db $00,$00,$00,$10,$10,$10,$10,$1F
db $20,$20,$1F,$2E,$2E,$2C,$2C,$FB
db $12,$12,$30,$00,$00,$00,$00,$10
db $10,$10,$10,$1F,$20,$20,$1F,$2E
db $2E,$2E,$2E,$F8,$11,$FF,$08,$08
db $00,$00,$00,$00,$10,$10,$10,$10
db $20,$20,$20,$20,$30,$30,$30,$30

YDisp:
db $12,$22,$18,$00,$10,$20,$30,$00
db $10,$20,$30,$00,$10,$20,$30,$00
db $10,$20,$30,$18,$16,$16,$12,$22
db $00,$10,$20,$30,$00,$10,$20,$30
db $00,$10,$20,$30,$00,$10,$20,$30

Tilemap:
db $C0,$E0,$E8,$80,$A0,$A0,$80,$82
db $A2,$A2,$82,$84,$A4,$C4,$E4,$86
db $A6,$C6,$E6,$E8,$C0,$E0,$E8,$80
db $A0,$A0,$80,$82,$A2,$A2,$82,$84
db $A4,$C4,$E4,$86,$A6,$C6,$E6,$E8
db $C0,$E0,$E8,$80,$A0,$A0,$80,$82
db $A2,$A2,$82,$84,$A4,$A4,$84,$86
db $A6,$A6,$86,$E8,$E8,$E8,$C2,$E2
db $80,$A0,$A0,$80,$82,$A2,$A2,$82
db $84,$A4,$C4,$E4,$86,$A6,$C6,$E6

TileProp:
db $00,$00,$40,$00,$00,$80,$80,$00
db $00,$80,$80,$00,$00,$00,$00,$00
db $00,$00,$00,$00,$00,$00,$40,$00
db $00,$80,$80,$00,$00,$80,$80,$00
db $00,$00,$00,$00,$00,$00,$00,$00
db $00,$00,$40,$00,$00,$80,$80,$00
db $00,$80,$80,$00,$00,$80,$80,$00
db $00,$80,$80,$00,$00,$40,$00,$00
db $00,$00,$80,$80,$00,$00,$80,$80
db $00,$00,$00,$00,$00,$00,$00,$00


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; init routine
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print "INIT ",pc

JSL $01ACF9
STA $1570,x

RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; main routine wrapper
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print "MAIN ",pc
PHB
PHK
PLB
JSR BigBooMain
PLB
RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; main routine
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BigBooMain:

JSR SubOffscreenX1

LDA #$20		;
STA $18B6	; unknown RAM address?

LDA $14C8,x	;
CMP #$08		; if the sprite is not in normal status...
BNE SkipToGFX	;
LDA $9D		; or sprites are locked...
BEQ ContinueMain	; skip most of the main routine and just run the GFX routine
SkipToGFX:	;
JMP InteractGFX	;

ContinueMain:	;

JSR SubHorzPos	;

LDA $1540,x	; if the timer is set...
BNE NoChangeState	;

LDA #$20			;
STA $1540,x		;
LDA $C2,x		; if the sprite state is zero...
BEQ NoCheckProximity	;
LDA $0F			;
CLC			;
ADC #$0A		;
CMP #$14			;
BCC Skip1		; skip the next part of code if the Boo is within a certain distance
NoCheckProximity:		;
LDA $7FAB10,x		;
AND #$04		; if the extra bit is set...
BNE NoChangeState		; make the Boo always follow the player
STZ $C2,x		;
CPY $76			; if the Boo is facing the player...
BNE NoChangeState		; don't make it follow him/her
INC $C2,x		;
NoChangeState:		;

LDA $0F			;
CLC			;
ADC #$0A		;
CMP #$14			;
BCC Skip1		;

LDA $15AC,x		; if the sprite is turning...
BNE Skip2			; skip the check and set
TYA			;
CMP $157C,x		;
BEQ Skip1			;
LDA #$1F			;
STA $15AC,x		; set the turn timer
BRA Skip2			;

Skip1:

STZ $1602,x		;
LDA $C2,x		;
BEQ Skip3			;
LDA #$03			;
STA $1602,x		;
AND $13			;
BNE Skip4			;
INC $1570,x		;
LDA $1570,x		;
BNE NoSetTimer2		;
LDA #$20			;
STA $1558,x		;
NoSetTimer2:		;
LDA $B6,x		; increment or decrement the sprite X speed
BEQ XSpdZero		; depending on whether it is positive, negative, or zero
BPL XSpdPlus		;
INC			;
INC			;
XSpdPlus:			;
DEC			;
XSpdZero:			;
STA $B6,x			;
LDA $AA,x		; same for the Y speed
BEQ YSpdZero		;
BPL YSpdPlus		;
INC			;
INC			;
YSpdPlus:			;
DEC			;
YSpdZero:			;
STA $AA,x		;

Skip4:
JMP UpdatePosition

Skip2:

CMP #$10		;
BNE NoFlipDir	;
PHA		;
LDA $157C,x	;
EOR #$01		; flip sprite direction
STA $157C,x	;
PLA		;
NoFlipDir:	;
LSR #3		;
TAY		;
LDA Frame,y	;
STA $1602,x	;

Skip3:

STZ $1570,x	;
LDA $13		;
AND #$07	; skip this every 8 frames
BNE UpdatePosition	;

JSR SubHorzPos	;

LDA $B6,x	;
CMP SpeedMax,y	;
BEQ NoIncXSpeed	;
CLC		;
ADC IncTable,y	;
STA $B6,x		;
NoIncXSpeed:	;

LDA $D3		;
PHA		;
SEC		;
SBC $18B6	;
STA $D3		;
LDA $D4		;
PHA		;
SBC #$00		;
STA $D4		;

JSR SubVertPos2	;

PLA		;
STA $D4		;
PLA		;
STA $D3		;

LDA $AA,x	;
CMP SpeedMax,y	;
BEQ UpdatePosition	;
CLC		;
ADC IncTable,y	;
STA $AA,x	;

UpdatePosition:

JSL $018022	;
JSL $01801A	;

InteractGFX:	;

LDA $14C8,x	;
CMP #$08		; if the sprite is not in normal status...
BNE NoInteraction	; don't interact with the player

JSL $01A7DC	;

NoInteraction:	;

JSR BigBooGFX	;

RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; graphics routine
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BigBooGFX:

JSR GetDrawInfo	;

LDA $1602,x	;
STA $06		;
ASL #2		;
STA $03		;
ASL #2		;
ADC $03		;
STA $02		;
LDA $157C,x	;
STA $04		;
LDA $15F6,x	;
STA $05		;
LDX #$00		;

GFXLoop:		;

PHX		;
LDX $02		;
LDA Tilemap,x	;
STA $0302,y	;

LDA $04		;
LSR		;
LDA TileProp,x	;
ORA $05		;
BCS NoFlipTile	;
EOR #$40		;
NoFlipTile:	;
ORA $64		;
STA $0303,y	;

LDA XDisp,x	;
BCS NoFlipXDisp	;
EOR #$FF		;
INC		;
CLC		;
ADC #$28	;
NoFlipXDisp:	;
CLC		;
ADC $00		;
STA $0300,y	;

PLX		;
PHX		;
LDA $06		;
CMP #$03		;
BCC NoAdd14	;
TXA		;
CLC		;
ADC #$14	;
TAX		;
NoAdd14:		;

LDA $01		;
CLC		;
ADC YDisp,x	;
STA $0301,y	;

PLX		;
INY #4		;
INC $02		;
INX		;
CPX #$14		;
BNE GFXLoop	;

LDX $15E9	;
LDA $1602,x	;
CMP #$03		;
BNE NoShift	;
LDA $1558,x	;
BEQ NoShift	;
LDY $15EA,x	;
LDA $0301,y	;
CLC		;
ADC #$05	;
STA $0301,y	;
STA $0305,y	;
NoShift:		;
LDA #$13		;
LDY #$02		;
JSL $81B7B3	;
RTS		;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; subroutines
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Table1:              db $0C,$1C
Table2:              db $01,$02
Table3:              db $40,$B0
Table6:              db $01,$FF
Table4:              db $30,$C0,$A0,$C0,$A0,$F0,$60,$90,$30,$C0,$A0,$80,$A0,$40,$60,$B0
Table5:              db $01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$00,$01,$FF

;SubOffscreenX0:
;LDA #$00
;BRA SubOffscreenMain
SubOffscreenX1:
LDA #$02
;BRA SubOffscreenMain
;SubOffscreenX2:
;LDA #$04
;BRA SubOffscreenMain
;SubOffscreenX3:
;LDA #$06
;BRA SubOffscreenMain
;SubOffscreenX4:
;LDA #$08
;BRA SubOffscreenMain
;SubOffscreenX5:
;LDA #$0A
;BRA SubOffscreenMain
;SubOffscreenX6:
;LDA #$0C
;BRA SubOffscreenMain
;SubOffscreenX7:
;LDA #$0E

SubOffscreenMain:

STA $03

JSR SubIsOffscreen
BEQ Return2

LDA $5B
LSR
BCS VerticalLevel
LDA $D8,x
CLC
ADC #$50
LDA $14D4,x
ADC #$00
CMP #$02
BPL EraseSprite
LDA $167A,x
AND #$04
BNE Return2
LDA $13
AND #$01
ORA $03
STA $01
TAY
LDA $1A
CLC
ADC Table4,y
ROL $00
CMP $E4,x
PHP
LDA $1B
LSR $00
ADC Table5,y
PLP
SBC $14E0,x
STA $00
LSR $01
BCC Label20
EOR #$80
STA $00
Label20:
LDA $00
BPL Return2

EraseSprite:
LDA $14C8,x
CMP #$08
BCC KillSprite
LDY $161A,x
CPY #$FF
BEQ KillSprite
LDA #$00
STA $1938,y
KillSprite:
STZ $14C8,x
Return2:
RTS

VerticalLevel:

LDA $167A,x
AND #$04
BNE Return2
LDA $13
LSR
BCS Return2
AND #$01
STA $01
TAY
LDA $1C
CLC
ADC Table3,y
ROL $00
CMP $D8,x
PHP
LDA $1D
LSR $00
ADC Table6,y
PLP
SBC $14D4,x
STA $00
LDY $02
BEQ Label22
EOR #$80
STA $00
Label22:
LDA $00
BPL Return2
BMI EraseSprite

SubIsOffscreen:
LDA $15A0,x
ORA $186C,x
RTS

GetDrawInfo:

STZ $186C,x
STZ $15A0,x
LDA $E4,x
CMP $1A
LDA $14E0,x
SBC $1B
BEQ OnscreenX
INC $15A0,x
OnscreenX:
LDA $14E0,x
XBA
LDA $E4,x
REP #$20
SEC
SBC $1A
CLC
ADC.w #$0040
CMP #$0180
SEP #$20
ROL A
AND #$01
STA $15C4,x
BNE Invalid

LDY #$00
LDA $1662,x
AND #$20
BEQ OnscreenLoop
INY
OnscreenLoop:
LDA $D8,x
CLC
ADC Table1,y
PHP
CMP $1C
ROL $00
PLP
LDA $14D4,x
ADC #$00
LSR $00
SBC $1D
BEQ OnscreenY
LDA $186C,x
ORA Table2,y
STA $186C,x
OnscreenY:
DEY
BPL OnscreenLoop
LDY $15EA,x
LDA $E4,x
SEC
SBC $1A
STA $00
LDA $D8,x
SEC
SBC $1C
STA $01
RTS

Invalid:
PLA
PLA
RTS

SubHorzPos:

LDY #$00
LDA $94
SEC
SBC $E4,x
STA $0F
LDA $95
SBC $14E0,x
BPL $01
INY
RTS

SubVertPos2:

LDY #$00
LDA $D3
SEC
SBC $D8,x
STA $0E
LDA $D4
SBC $14D4,x
BPL $01
INY
RTS











